package mainapp;

import java.io.IOException;
import java.io.PrintWriter;
import java.sql.SQLException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

public class SaveOptionsAction extends HttpServlet {

    /**
     * Processes requests for both HTTP <code>GET</code> and <code>POST</code>
     * methods.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        if  (request.getParameter("normal_price") == null || request.getParameter("normal_price") == null 
                || request.getParameter("normal_price") == null) {
            request.setAttribute("errorMessage", "Παρακαλώ συμπληρώστε όλα τα πεδία");
            request.getRequestDispatcher("?action=options").forward(request, response);
            return;
        }
        float normalPrice;
        float bioPrice;
        float step;
        try {
            normalPrice = Float.parseFloat(request.getParameter("normal_price"));
            bioPrice = Float.parseFloat(request.getParameter("bio_price"));
            step = Float.parseFloat(request.getParameter("step"));
        } catch (NullPointerException | NumberFormatException ex) {
            request.setAttribute("errorMessage", "Παρακαλώ συμπληρώστε όλα τα πεδία με έγκυρα ποσά");
            request.getRequestDispatcher("?action=options").forward(request, response);
            return;
        }
        PricingOptions opts;
        try {
            opts = new PricingOptions(false);
        } catch (ClassNotFoundException | SQLException ex) {
            request.setAttribute("errorMessage", "Συνέβει κάποιο σφάλμα. Προσπαθήστε ξανά");
            request.getRequestDispatcher("?action=options").forward(request, response);
            return;
        }
        opts.setNormalPrice(normalPrice);
        opts.setBioPrice(bioPrice);
        opts.setAcidityStep(step);
        opts.save();
        response.sendRedirect("?action=options");
    }

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /**
     * Handles the HTTP <code>GET</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Handles the HTTP <code>POST</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Returns a short description of the servlet.
     *
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>

}
